# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class IIdType(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'base_url': 'str',
        'id_part_as_long': 'int',
        'version_id_part': 'str',
        'version_id_part_as_long': 'int',
        'id_part_valid': 'bool',
        'id_part_valid_long': 'bool',
        'version_id_part_valid_long': 'bool',
        'resource_type': 'str',
        'id_part': 'str',
        'local': 'bool',
        'empty': 'bool',
        'value': 'str',
        'absolute': 'bool',
        'value_as_string': 'str',
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]'
    }

    attribute_map = {
        'base_url': 'baseUrl',
        'id_part_as_long': 'idPartAsLong',
        'version_id_part': 'versionIdPart',
        'version_id_part_as_long': 'versionIdPartAsLong',
        'id_part_valid': 'idPartValid',
        'id_part_valid_long': 'idPartValidLong',
        'version_id_part_valid_long': 'versionIdPartValidLong',
        'resource_type': 'resourceType',
        'id_part': 'idPart',
        'local': 'local',
        'empty': 'empty',
        'value': 'value',
        'absolute': 'absolute',
        'value_as_string': 'valueAsString',
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost'
    }

    def __init__(self, base_url=None, id_part_as_long=None, version_id_part=None, version_id_part_as_long=None, id_part_valid=None, id_part_valid_long=None, version_id_part_valid_long=None, resource_type=None, id_part=None, local=None, empty=None, value=None, absolute=None, value_as_string=None, format_comments_pre=None, format_comments_post=None):  # noqa: E501
        """IIdType - a model defined in Swagger"""  # noqa: E501

        self._base_url = None
        self._id_part_as_long = None
        self._version_id_part = None
        self._version_id_part_as_long = None
        self._id_part_valid = None
        self._id_part_valid_long = None
        self._version_id_part_valid_long = None
        self._resource_type = None
        self._id_part = None
        self._local = None
        self._empty = None
        self._value = None
        self._absolute = None
        self._value_as_string = None
        self._format_comments_pre = None
        self._format_comments_post = None
        self.discriminator = None

        if base_url is not None:
            self.base_url = base_url
        if id_part_as_long is not None:
            self.id_part_as_long = id_part_as_long
        if version_id_part is not None:
            self.version_id_part = version_id_part
        if version_id_part_as_long is not None:
            self.version_id_part_as_long = version_id_part_as_long
        if id_part_valid is not None:
            self.id_part_valid = id_part_valid
        if id_part_valid_long is not None:
            self.id_part_valid_long = id_part_valid_long
        if version_id_part_valid_long is not None:
            self.version_id_part_valid_long = version_id_part_valid_long
        if resource_type is not None:
            self.resource_type = resource_type
        if id_part is not None:
            self.id_part = id_part
        if local is not None:
            self.local = local
        if empty is not None:
            self.empty = empty
        if value is not None:
            self.value = value
        if absolute is not None:
            self.absolute = absolute
        if value_as_string is not None:
            self.value_as_string = value_as_string
        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post

    @property
    def base_url(self):
        """Gets the base_url of this IIdType.  # noqa: E501


        :return: The base_url of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._base_url

    @base_url.setter
    def base_url(self, base_url):
        """Sets the base_url of this IIdType.


        :param base_url: The base_url of this IIdType.  # noqa: E501
        :type: str
        """

        self._base_url = base_url

    @property
    def id_part_as_long(self):
        """Gets the id_part_as_long of this IIdType.  # noqa: E501


        :return: The id_part_as_long of this IIdType.  # noqa: E501
        :rtype: int
        """
        return self._id_part_as_long

    @id_part_as_long.setter
    def id_part_as_long(self, id_part_as_long):
        """Sets the id_part_as_long of this IIdType.


        :param id_part_as_long: The id_part_as_long of this IIdType.  # noqa: E501
        :type: int
        """

        self._id_part_as_long = id_part_as_long

    @property
    def version_id_part(self):
        """Gets the version_id_part of this IIdType.  # noqa: E501


        :return: The version_id_part of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._version_id_part

    @version_id_part.setter
    def version_id_part(self, version_id_part):
        """Sets the version_id_part of this IIdType.


        :param version_id_part: The version_id_part of this IIdType.  # noqa: E501
        :type: str
        """

        self._version_id_part = version_id_part

    @property
    def version_id_part_as_long(self):
        """Gets the version_id_part_as_long of this IIdType.  # noqa: E501


        :return: The version_id_part_as_long of this IIdType.  # noqa: E501
        :rtype: int
        """
        return self._version_id_part_as_long

    @version_id_part_as_long.setter
    def version_id_part_as_long(self, version_id_part_as_long):
        """Sets the version_id_part_as_long of this IIdType.


        :param version_id_part_as_long: The version_id_part_as_long of this IIdType.  # noqa: E501
        :type: int
        """

        self._version_id_part_as_long = version_id_part_as_long

    @property
    def id_part_valid(self):
        """Gets the id_part_valid of this IIdType.  # noqa: E501


        :return: The id_part_valid of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._id_part_valid

    @id_part_valid.setter
    def id_part_valid(self, id_part_valid):
        """Sets the id_part_valid of this IIdType.


        :param id_part_valid: The id_part_valid of this IIdType.  # noqa: E501
        :type: bool
        """

        self._id_part_valid = id_part_valid

    @property
    def id_part_valid_long(self):
        """Gets the id_part_valid_long of this IIdType.  # noqa: E501


        :return: The id_part_valid_long of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._id_part_valid_long

    @id_part_valid_long.setter
    def id_part_valid_long(self, id_part_valid_long):
        """Sets the id_part_valid_long of this IIdType.


        :param id_part_valid_long: The id_part_valid_long of this IIdType.  # noqa: E501
        :type: bool
        """

        self._id_part_valid_long = id_part_valid_long

    @property
    def version_id_part_valid_long(self):
        """Gets the version_id_part_valid_long of this IIdType.  # noqa: E501


        :return: The version_id_part_valid_long of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._version_id_part_valid_long

    @version_id_part_valid_long.setter
    def version_id_part_valid_long(self, version_id_part_valid_long):
        """Sets the version_id_part_valid_long of this IIdType.


        :param version_id_part_valid_long: The version_id_part_valid_long of this IIdType.  # noqa: E501
        :type: bool
        """

        self._version_id_part_valid_long = version_id_part_valid_long

    @property
    def resource_type(self):
        """Gets the resource_type of this IIdType.  # noqa: E501


        :return: The resource_type of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this IIdType.


        :param resource_type: The resource_type of this IIdType.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def id_part(self):
        """Gets the id_part of this IIdType.  # noqa: E501


        :return: The id_part of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._id_part

    @id_part.setter
    def id_part(self, id_part):
        """Sets the id_part of this IIdType.


        :param id_part: The id_part of this IIdType.  # noqa: E501
        :type: str
        """

        self._id_part = id_part

    @property
    def local(self):
        """Gets the local of this IIdType.  # noqa: E501


        :return: The local of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._local

    @local.setter
    def local(self, local):
        """Sets the local of this IIdType.


        :param local: The local of this IIdType.  # noqa: E501
        :type: bool
        """

        self._local = local

    @property
    def empty(self):
        """Gets the empty of this IIdType.  # noqa: E501


        :return: The empty of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this IIdType.


        :param empty: The empty of this IIdType.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def value(self):
        """Gets the value of this IIdType.  # noqa: E501


        :return: The value of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this IIdType.


        :param value: The value of this IIdType.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def absolute(self):
        """Gets the absolute of this IIdType.  # noqa: E501


        :return: The absolute of this IIdType.  # noqa: E501
        :rtype: bool
        """
        return self._absolute

    @absolute.setter
    def absolute(self, absolute):
        """Sets the absolute of this IIdType.


        :param absolute: The absolute of this IIdType.  # noqa: E501
        :type: bool
        """

        self._absolute = absolute

    @property
    def value_as_string(self):
        """Gets the value_as_string of this IIdType.  # noqa: E501


        :return: The value_as_string of this IIdType.  # noqa: E501
        :rtype: str
        """
        return self._value_as_string

    @value_as_string.setter
    def value_as_string(self, value_as_string):
        """Sets the value_as_string of this IIdType.


        :param value_as_string: The value_as_string of this IIdType.  # noqa: E501
        :type: str
        """

        self._value_as_string = value_as_string

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this IIdType.  # noqa: E501


        :return: The format_comments_pre of this IIdType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this IIdType.


        :param format_comments_pre: The format_comments_pre of this IIdType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this IIdType.  # noqa: E501


        :return: The format_comments_post of this IIdType.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this IIdType.


        :param format_comments_post: The format_comments_post of this IIdType.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IIdType):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
